#!/usr/bin/perl

# GH_ERRORS.PL
# Search for Genehunter error messages in all GH-outfiles in all chromosome subdirectories
# (c) Created by Franz Rueschendorf 30-Jan-2004
#
# Option -nw : Don't show Genehunter WARNINGs

print "\nSearch for Genehunter error messages\n\n";

if ($ARGV[0] eq "-nw") {$var="ERR\|SKIP\|FAIL\|PVECT";}
else {$var="ERR|SKIP|WARN|FAIL|PVECT";}

my $outfile ="gh_errors.out";
open (OUT, "> $outfile") || print "could not open outfile $outfile :$!\n";

foreach my $dir (c01,c02,c03,c04,c05,c06,c07,c08,c09,c10,c11,c12,c13,c14,c15,c16,c17,c18,c19,c20,c21,c22,c23,cx,c24,cxy) {
	if (-d $dir) {
		
		print "Chromosome: $dir\n";
		@files= glob("$dir/gh*.out");		# all genehunter outfiles
		foreach $infile (@files) {
			print OUT "File:  $infile\n";
			&ReadInfile;
		}
	}
	else {
		print OUT "No directory $dir\n";
	} 
}
close (OUT);
print "\nResults are in $outfile\n\n";

###################################  ReadInfile  #####################################
sub ReadInfile {

	my $nan=0;
	open (IN, "$infile") || print "could not open $infile :$!\n";
 	while (<IN>){
 		next if /^$/;
 		if (uc($_) =~ /$var/) {
    		print OUT "\t$_";
    	}
    	if ($_ =~ /NaN/){$nan=1;}
    	
    }
	close (IN);
    if ($nan == 1) {print OUT "\tproblem with calculation of scores: NaN\n";}
}


#####################################   E N D   #####################################
