#!/usr/bin/perl

# MERLIN_ERRORS.PL
# Search for MERLIN error messages in all merlin.out in all chromosome subdirectories
# (c) Created by Franz Rueschendorf 11-Jul-2007
# Modified 21-May-2008
#
# Option -nw : Don't show WARNINGs

use strict;

print "\nSearch for Merlin error messages\n\n";

my ($var,$infile);
my @files=();

if ($ARGV[0] eq "-nw") {$var="ERRO\|SKIP\|SWAP";}
else {$var="ERRO|SKIP|WARN|SWAP";}

my $outfile ="merlin_errors.out";
open (OUT, "> $outfile") || print "could not open outfile $outfile :$!\n";

foreach my $dir qw(c01 c02 c03 c04 c05 c06 c07 c08 c09 c10 c11 c12 c13 c14 c15 c16 c17 c18 c19 c20 c21 c22 c23 c24) {
	if (-d $dir) {
		print "Chromosome: $dir\n";

		$infile="${dir}/merlin.out";
		if (-f "$infile") {		
			print OUT "File:  $infile";
			&ReadInfile;
		}
		else {		
			@files= glob("$dir/merlin_*.out");		# all Merlin logfiles

			foreach (@files) {
				$infile=$_;
				print OUT "File:  $infile";
				&ReadInfile;
			}
		}
	}
	else {
		print OUT "No directory $dir\n";
	} 
}
close (OUT);
print "\nResults are in $outfile\n\n";

###################################  ReadInfile  #####################################
sub ReadInfile {
	my $err=0;
	open (IN, "$infile") || print "could not open $infile :$!\n";
 	while (<IN>){
 		next if /^$/;
 		if (uc($_) =~ /$var/) {
 			if (($_ =~ /General :/) || ($_ =~ /Performance :/)) { next; }
 			$err++;
 			if ($err == 1) { print OUT "\n"; }
    		print OUT "\t$_";
    	}
    }
	close (IN);
	if ($err == 0) { print OUT "  OK\n";}
}


#####################################   E N D   #####################################
